const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const materiais_atividade = sequelize.define(
    'materiais_atividade',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      quantidade_prevista: {
        type: DataTypes.DECIMAL,
      },

      unidade_medida: {
        type: DataTypes.TEXT,
      },

      tolerancia_estoque: {
        type: DataTypes.DECIMAL,
      },

      comentarios: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  materiais_atividade.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.materiais_atividade.belongsTo(db.estrutura_projeto, {
      as: 'estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    db.materiais_atividade.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.materiais_atividade.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.materiais_atividade.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return materiais_atividade;
};
